package dao

import (
	dbModel "sdk_api/model/db"

	"gorm.io/gorm"
)

func (d *Dao) CreateProject(p *dbModel.Project) (err error) {
	return d.db.Create(p).Error
}

func (d *Dao) GetProjectList(page, pageSize int) (list []*dbModel.Project, err error) {
	return list, d.db.Limit(pageSize).Offset((page - 1) * pageSize).Find(&list).Error
}

func (d *Dao) GetProject(id int) (p *dbModel.Project, err error) {
	p = &dbModel.Project{}
	err = d.db.Where("`id` = ?", id).First(&p).Error
	if err == gorm.ErrRecordNotFound {
		return nil, nil
	}
	return p, err
}

func (d *Dao) CreateGroup(g *dbModel.TaskGroup) (err error) {
	return d.db.Create(g).Error
}

func (d *Dao) GetGroupList(page, pageSize int) (list []*dbModel.TaskGroup, err error) {
	return list, d.db.Limit(pageSize).Offset((page - 1) * pageSize).Find(&list).Error
}

func (d *Dao) GetGroup(id int) (g *dbModel.TaskGroup, err error) {
	g = &dbModel.TaskGroup{}
	err = d.db.Where("`id` = ?", id).First(&g).Error
	if err == gorm.ErrRecordNotFound {
		return nil, nil
	}
	return g, err
}

func (d *Dao) GetGroupTasks(gid int) (list []*dbModel.Task, err error) {
	return list, d.db.Where("`group_id` = ?", gid).Find(&list).Error
}

func (d *Dao) CreateGroupTask(gt *dbModel.Task) (err error) {
	return d.db.Create(gt).Error
}
