package db_model

import (
	"gorm.io/gorm"
)

type Project struct {
	Id             int    `gorm:"primaryKey;autoIncrement:false"`
	Name           string `gorm:"type:text;not null;comment:项目名称"`
	TelegramChatId int    `gorm:"type:int;not null;comment:telegram群id"`
	TwitterHandle  string `gorm:"type:text;not null;comment:twitter用户名"`
	gorm.Model

	Groups []*TaskGroup
}

type TaskGroup struct {
	Id          int    `gorm:"primaryKey;autoIncrement:false"`
	ProjectId   int    `gorm:"type:int;not null;comment:项目id"`
	Description string `gorm:"type:text;not null;comment:任务组描述"`
	gorm.Model
}

type Task struct {
	Id          int    `gorm:"primaryKey;autoIncrement:false"`
	GroupId     int    `gorm:"type:int;index;not null;comment:任务组id"`
	Platform    string `gorm:"type:text;not null;comment:任务平台"`
	Action      string `gorm:"type:text;not null;comment:任务动作"`
	Url         string `gorm:"type:text;not null;comment:任务地址"`
	Description string `gorm:"type:text;not null;comment:任务描述"`
	Reward      int    `gorm:"type:int;not null;comment:任务奖励"`
	Start       int    `gorm:"type:int;not null;comment:任务开始时间"`
	End         int    `gorm:"type:int;not null;comment:任务结束时间"`
	gorm.Model
}

type TaskHistory struct {
	Id     int    `gorm:"primaryKey"`
	TaskId int    `gorm:"type:int;index;not null;comment:任务id"`
	User   string `gorm:"type:text;not null;comment:用户"`
	gorm.Model
}
